import java.io.*;
import java.awt.*;
import java.awt.event.*; 
import javax.swing.*; 
import javax.swing.event.*; 

public class Inscriptor extends JFrame { 

	public Inscriptor(String alumno, String asignatura) {
		setTitle(asignatura + ": Proyecto personal de " + alumno);
		setSize(400, 500);
		setLocation(10, 10);
		gui = new InscriptorGUI(alumno, asignatura);

		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0); 
			} 
		} );
 
		getContentPane().add(gui);
		setVisible(true); 
	} 

	InscriptorGUI gui;
}

class InscriptorGUI extends JPanel {

	public InscriptorGUI(String alumno, String asignatura) {
		proyecto = new Proyecto();
		proyecto.setNombreAlumno(alumno);
		this.asignatura = new String(asignatura);

		setLayout(new FlowLayout(FlowLayout.LEFT));

		add(eAsignatura);
		add(eAlumno);
		add(e01);
		add(fNombreProyecto);
		add(e02);
		add(aDescripcionProblema);
		add(e03);
		add(aSolucionInicial);
		add(bAceptar);
		add(bCancelar);

		bAceptar.addActionListener(alAceptar);
		bCancelar.addActionListener(alCancelar);

		eAsignatura.setText(this.asignatura + utilString.sps);
		eAlumno.setText(alumno + utilString.sps);
		fNombreProyecto.setText(proyecto.getNombreProyecto());
		aDescripcionProblema.setText(proyecto.getDescripcionProblema());
		aSolucionInicial.setText(proyecto.getSolucionInicial());
		e01.setText("Nombre del Proyecto" + utilString.sps);
		e02.setText("Descripcion del problema" + utilString.sps);
		e03.setText("Idea inicial para la solucion" + utilString.sps);

		aDescripcionProblema.setLineWrap(true);
		aDescripcionProblema.setWrapStyleWord(true);
		aSolucionInicial.setLineWrap(true);
		aSolucionInicial.setWrapStyleWord(true);
	}

	public void escribirEnArchivo() {
		proyecto.setNombreProyecto(fNombreProyecto.getText());
		proyecto.setDescripcionProblema(
			utilString.reemplazar(
				aDescripcionProblema.getText(), "\n", "<br>"));
		proyecto.setSolucionInicial(
			utilString.reemplazar(
				aSolucionInicial.getText(), "\n", "<br>"));
		try {
			PrintWriter pw = new PrintWriter(
				new BufferedWriter(new FileWriter(
					"proyectos" + asignatura + ".txt", true)));

			pw.println(proyecto);
			pw.close();
			System.out.println("Inscripcion realizada.");
		} catch(Throwable excepcion) {
			System.out.println(excepcion);
			System.out.println("Hubo un problema con su inscripcion.");
		}
		finalizar();
	}

	private void finalizar(){
		System.out.println("Hasta luego, " + proyecto.getNombreAlumno());
		System.exit(0);
	}

	// Las etiquetas.
	private JLabel eAsignatura = new JLabel();
	private JLabel eAlumno = new JLabel();
	private JLabel e01 = new JLabel();
	private JLabel e02 = new JLabel();
	private JLabel e03 = new JLabel();
	// El campo de texto.
	private JTextField fNombreProyecto = new JTextField(30);
	// Las areas de texto
	private JTextArea aDescripcionProblema = new JTextArea(10, 30);
	private JTextArea aSolucionInicial = new JTextArea(10, 30);
	// Los botones.
	private JButton bAceptar = new JButton("Aceptar");
	private JButton bCancelar = new JButton("Cancelar");
	// Los action listener.
	private ActionListener alAceptar = new ActionListener() {
		public void actionPerformed(ActionEvent e){
			escribirEnArchivo();
	} };
	private ActionListener alCancelar = new ActionListener() {
		public void actionPerformed(ActionEvent e){
			finalizar();
	} };

	private String asignatura;
	private Proyecto proyecto;
}

