import java.io.*;

/**
 * Almacena los datos del proyecto.
 */
public class Proyecto {

/**
 * Constructor.
 */
	public Proyecto () {
		nombreAlumno = new String("desconocido");
		nombreProyecto = new String("desconocido");
		descripcionProblema = new String("desconocido");
		solucionInicial = new String("desconocido");
	}

/**
 * Constructor.
 * @param alumno El nombre del alumno.
 * @param proyecto El nombre del proyecto.
 * @param descripcion Breve descripci&oacute;n del problema.
 * @param solucion Idea inicial para una posible soluci&oacute;n.
 */
	public Proyecto (String alumno, String proyecto, String descripcion, String solucion) {
		nombreAlumno = new String(alumno);
		nombreProyecto = new String(proyecto);
		descripcionProblema = new String(descripcion);
		solucionInicial = new String(solucion);
	}

/**
 * Constructor.
 * @param proyecto El Proyecto cuyos datos inicializar&aacute;n el nuevo
 * Proyecto.
 */
	public Proyecto (Proyecto proyecto) {
		nombreAlumno = new String(proyecto.nombreAlumno);
		nombreProyecto = new String(proyecto.nombreProyecto);
		descripcionProblema = new String(proyecto.descripcionProblema);
		solucionInicial = new String(proyecto.solucionInicial);
	}

	public void setNombreAlumno(String alumno) {
		nombreAlumno = new String(alumno);
	}

	public void setNombreProyecto(String proyecto) {
		nombreProyecto = new String(proyecto);
	}

	public void setDescripcionProblema(String descripcion) {
		descripcionProblema = new String(descripcion);
	}

	public void setSolucionInicial(String solucion) {
		solucionInicial = new String(solucion);
	}

	public String getNombreAlumno() {
		return new String(nombreAlumno);
	}

	public String getNombreProyecto() {
		return new String(nombreProyecto);
	}

	public String getDescripcionProblema() {
		return new String(descripcionProblema);
	}

	public String getSolucionInicial() {
		return new String(solucionInicial);
	}

	public String toString() {
		return new String("<proyecto>\n"
			+ "<nombre_alumno>\n" 
			+ nombreAlumno
			+ "\n</nombre_alumno>\n"
			+ "<nombre_proyecto>\n"
			+ nombreProyecto
			+ "\n</nombre_proyecto>\n"
			+ "<descripcion_problema>\n"
			+ descripcionProblema
			+ "\n</descripcion_problema>\n"
			+ "<solucion_inicial>\n"
			+ solucionInicial
			+ "\n</solucion_inicial>\n"
			+ "</proyecto>" );
	}

/**
 * Escribe los datos del proyecto en formato HTML, utilizando un
 * <TT>modelo</TT>.
 * @param modelo El c&oacute;digo HTML que servir&aacute; de base para el 
 * 		resultado.
 * @return El c&oacute;digo HTML con los datos.
 */
	public String toStringHTML(String modelo) {
		String s = new String(); 
		String temp = new String();
		try {
			BufferedReader br = 
				new BufferedReader(
					new FileReader(modelo));

			while((temp = br.readLine()) != null) {
				if(temp.equalsIgnoreCase("<!--nombre_alumno-->")) {
					s = s + nombreAlumno + "\n";
				}
				else if(temp.equalsIgnoreCase("<!--nombre_proyecto-->")) {
					s = s + nombreProyecto + "\n";
				}
				else if(temp.equalsIgnoreCase("<!--descripcion_problema-->")) {
					s = s + descripcionProblema + "\n";
				}
				else if(temp.equalsIgnoreCase("<!--solucion_inicial-->")) {
					s = s + solucionInicial + "\n";
				}
				else {
					s = s + temp + "\n";
				}
			}

			br.close();
		} catch(Throwable excepcion) {
			System.out.println(excepcion);
			s = "Error";
		}
		return s;
	}

	public void setProyectoDesdeArchivo(BufferedReader br) {
		String temp = new String();
		try {
			temp = br.readLine(); // <nombre_alumno>
			setNombreAlumnoDesdeArchivo(br);
			temp = br.readLine(); // <nombre_proyecto>
			setNombreProyectoDesdeArchivo(br);
			temp = br.readLine(); // <descripcion_problema>
			setDescripcionProblemaDesdeArchivo(br);
			temp = br.readLine(); // <solucion_inicial>
			setSolucionInicialDesdeArchivo(br);
			temp = br.readLine(); // </proyecto>
		} catch(Throwable excepcion) {
			System.out.println(excepcion);
		}
	}

	public void setNombreAlumnoDesdeArchivo(BufferedReader br) {
		String s = new String();
		String temp = new String();
		try {
			while(!((temp = br.readLine()).equalsIgnoreCase("</nombre_alumno>")))
				s = s + temp;

			nombreAlumno = s;
		} catch(Throwable excepcion) {
			System.out.println(excepcion);
		}
	}

	public void setNombreProyectoDesdeArchivo(BufferedReader br) {
		String s = new String();
		String temp = new String();
		try {
			while(!((temp = br.readLine()).equalsIgnoreCase("</nombre_proyecto>")))
				s = s + temp;

			nombreProyecto = s;
		} catch(Throwable excepcion) {
			System.out.println(excepcion);
		}
	}

	public void setDescripcionProblemaDesdeArchivo(BufferedReader br) {
		String s = new String();
		String temp = new String();
		try {
			while(!((temp = br.readLine()).equalsIgnoreCase("</descripcion_problema>")))
				s = s + temp;

			descripcionProblema = s;
		} catch(Throwable excepcion) {
			System.out.println(excepcion);
		}
	}

	public void setSolucionInicialDesdeArchivo(BufferedReader br) {
		String s = new String();
		String temp = new String();
		try {
			while(!((temp = br.readLine()).equalsIgnoreCase("</solucion_inicial>")))
				s = s + temp;

			solucionInicial = s;
		} catch(Throwable excepcion) {
			System.out.println(excepcion);
		}
	}

	private String nombreAlumno;
	private String nombreProyecto;
	private String descripcionProblema;
	private String solucionInicial;
}