import java.io.*;
import java.util.*;

/**
 * Esta es una clase que contiene m&eacute;todos est&aacute;ticos para
 * trabajar con <B>Strings</B> y archivos.
 */
public class utilString {

/**
 * Reemplaza en el <B>String</B> <TT>cadena</TT> todos los substrings
 * especificados por <TT>clave</TT>, por el substring indicado por
 * <TT>reemplazo</TT>
 * @param cadena El <B>String</B> donde se realizar&aacute; el reemplazo.
 * @param clave El substring a ser reemplazado.
 * @param reemplazo El substring por que ser&aacute; reemplazado
 * 		<TT>clave</TT>.
 * @return Retorna un nuevo <B>String</B> con los reemplazos efectuados.
 */
	public static String reemplazar(String cadena, String clave, String reemplazo) {
		StringBuffer sbcadena = new StringBuffer(cadena);
		int indice;

		while((indice = sbcadena.indexOf(clave)) != -1) {
			sbcadena = sbcadena.delete(indice, indice + clave.length());
			sbcadena = sbcadena.insert(indice, reemplazo);
		}
		return sbcadena.toString();
	}

/**
 * Verifica si el <B>String</B> <TT>clave</TT> esta contenido en 
 * <TT>archivo</TT>.
 * El <B>String</B> <TT>clave</TT> debe ocupar una linea entera 
 * en <TT>archivo</TT>.
 * @param clave El <B>String</B> cuya presencia se quiere detectar.
 * @param archivo El archivo donde se buscar&aacute; el string.
 * @return <TT>True</TT> si <TT>clave</TT> se encuentra. <TT>False</TT>
 * en caso contrario o si <TT>archivo</TT> no existe.
 */
	public static boolean estaContenido(String clave, String archivo) {
		boolean existe = false;
		String linea;
		try {
			BufferedReader br = 
				new BufferedReader(
					new FileReader(archivo));


			while(((linea = br.readLine()) != null) && (!existe)) {
				if(linea.equalsIgnoreCase(clave))
					existe = true;
			}

			br.close();
		}
		catch(FileNotFoundException excepcion1) {
			existe = false;
		}
		catch(Throwable excepcion) {
			System.out.println(excepcion);
			existe = false;
		}
			return existe;
	}

/**
 * Dado el <B>String</B> <TT>rol</TT>, entrega el nombre que le 
 * corresponde, de acuerdo a <TT>archivo</TT>.
 * El nombre debe ir en la linea siguiente al <TT>rol</TT>.
 * Cada nombre y cada rol, deben ir en lineas diferentes.
 * @param rol El rol.
 * @param archivo El archivo de roles y nombres.
 * @return El nombre correspondiente a <TT>rol</TT>.
 */
	public static String quienEs(String rol, String archivo) {
		String linea, nombre = new String();
		boolean existe = false;
		try {
			BufferedReader br =
				 new BufferedReader(
					new FileReader(archivo));


			while(((linea = br.readLine()) != null) && (!existe)) {
				if(linea.equalsIgnoreCase(rol)) {
					existe = true;
					nombre = br.readLine();
				}
			}

			br.close();
		}
		catch(Throwable excepcion) {
			System.out.println(excepcion);
			nombre = new String("desconocido");
		}
		return new String(nombre);
	}

	public static String sps = "                                                    ";

}